diff --git a/resources/smarteiffel-germ/compile_to_c.make b/resources/smarteiffel-germ/compile_to_c.make
index 4d26e57..83b36dc 100644
--- a/resources/smarteiffel-germ/compile_to_c.make
+++ b/resources/smarteiffel-germ/compile_to_c.make
@@ -135,5 +135,5 @@ gcc -pipe -O2 -c -x c compile_to_c3.c
 gcc -pipe -O2 -c -x c compile_to_c2.c
 gcc -pipe -O2 -c -x c compile_to_c1.c
 # End of parallelizable section
-gcc -Xlinker -no-as-needed compile_to_c1.o compile_to_c2.o compile_to_c3.o compile_to_c4.o compile_to_c5.o compile_to_c6.o compile_to_c7.o compile_to_c8.o compile_to_c9.o compile_to_c10.o compile_to_c11.o compile_to_c12.o compile_to_c13.o compile_to_c14.o compile_to_c15.o compile_to_c16.o compile_to_c17.o compile_to_c18.o compile_to_c19.o compile_to_c20.o compile_to_c21.o compile_to_c22.o compile_to_c23.o compile_to_c24.o compile_to_c25.o compile_to_c26.o compile_to_c27.o compile_to_c28.o compile_to_c29.o compile_to_c30.o compile_to_c31.o compile_to_c32.o compile_to_c33.o compile_to_c34.o compile_to_c35.o compile_to_c36.o compile_to_c37.o compile_to_c38.o compile_to_c39.o compile_to_c40.o compile_to_c41.o compile_to_c42.o compile_to_c43.o compile_to_c44.o compile_to_c45.o compile_to_c46.o compile_to_c47.o compile_to_c48.o compile_to_c49.o compile_to_c50.o compile_to_c51.o compile_to_c52.o compile_to_c53.o compile_to_c54.o compile_to_c55.o compile_to_c56.o compile_to_c57.o compile_to_c58.o compile_to_c59.o compile_to_c60.o compile_to_c61.o compile_to_c62.o compile_to_c63.o compile_to_c64.o compile_to_c65.o compile_to_c66.o compile_to_c67.o compile_to_c68.o compile_to_c69.o compile_to_c70.o compile_to_c71.o compile_to_c72.o compile_to_c73.o compile_to_c74.o compile_to_c75.o compile_to_c76.o compile_to_c77.o compile_to_c78.o compile_to_c79.o compile_to_c80.o compile_to_c81.o compile_to_c82.o compile_to_c83.o compile_to_c84.o compile_to_c85.o compile_to_c86.o compile_to_c87.o compile_to_c88.o compile_to_c89.o compile_to_c90.o compile_to_c91.o compile_to_c92.o compile_to_c93.o compile_to_c94.o compile_to_c95.o compile_to_c96.o compile_to_c97.o compile_to_c98.o compile_to_c99.o compile_to_c100.o compile_to_c101.o compile_to_c102.o compile_to_c103.o compile_to_c104.o compile_to_c105.o compile_to_c106.o compile_to_c107.o compile_to_c108.o compile_to_c109.o compile_to_c110.o compile_to_c111.o compile_to_c112.o compile_to_c113.o compile_to_c114.o compile_to_c115.o compile_to_c116.o compile_to_c117.o compile_to_c118.o compile_to_c119.o compile_to_c120.o compile_to_c121.o compile_to_c122.o compile_to_c123.o compile_to_c124.o compile_to_c125.o compile_to_c126.o compile_to_c127.o compile_to_c128.o compile_to_c129.o compile_to_c130.o compile_to_c131.o compile_to_c132.o compile_to_c133.o compile_to_c134.o compile_to_c135.o -x none
+gcc ${LDFLAGS} compile_to_c1.o compile_to_c2.o compile_to_c3.o compile_to_c4.o compile_to_c5.o compile_to_c6.o compile_to_c7.o compile_to_c8.o compile_to_c9.o compile_to_c10.o compile_to_c11.o compile_to_c12.o compile_to_c13.o compile_to_c14.o compile_to_c15.o compile_to_c16.o compile_to_c17.o compile_to_c18.o compile_to_c19.o compile_to_c20.o compile_to_c21.o compile_to_c22.o compile_to_c23.o compile_to_c24.o compile_to_c25.o compile_to_c26.o compile_to_c27.o compile_to_c28.o compile_to_c29.o compile_to_c30.o compile_to_c31.o compile_to_c32.o compile_to_c33.o compile_to_c34.o compile_to_c35.o compile_to_c36.o compile_to_c37.o compile_to_c38.o compile_to_c39.o compile_to_c40.o compile_to_c41.o compile_to_c42.o compile_to_c43.o compile_to_c44.o compile_to_c45.o compile_to_c46.o compile_to_c47.o compile_to_c48.o compile_to_c49.o compile_to_c50.o compile_to_c51.o compile_to_c52.o compile_to_c53.o compile_to_c54.o compile_to_c55.o compile_to_c56.o compile_to_c57.o compile_to_c58.o compile_to_c59.o compile_to_c60.o compile_to_c61.o compile_to_c62.o compile_to_c63.o compile_to_c64.o compile_to_c65.o compile_to_c66.o compile_to_c67.o compile_to_c68.o compile_to_c69.o compile_to_c70.o compile_to_c71.o compile_to_c72.o compile_to_c73.o compile_to_c74.o compile_to_c75.o compile_to_c76.o compile_to_c77.o compile_to_c78.o compile_to_c79.o compile_to_c80.o compile_to_c81.o compile_to_c82.o compile_to_c83.o compile_to_c84.o compile_to_c85.o compile_to_c86.o compile_to_c87.o compile_to_c88.o compile_to_c89.o compile_to_c90.o compile_to_c91.o compile_to_c92.o compile_to_c93.o compile_to_c94.o compile_to_c95.o compile_to_c96.o compile_to_c97.o compile_to_c98.o compile_to_c99.o compile_to_c100.o compile_to_c101.o compile_to_c102.o compile_to_c103.o compile_to_c104.o compile_to_c105.o compile_to_c106.o compile_to_c107.o compile_to_c108.o compile_to_c109.o compile_to_c110.o compile_to_c111.o compile_to_c112.o compile_to_c113.o compile_to_c114.o compile_to_c115.o compile_to_c116.o compile_to_c117.o compile_to_c118.o compile_to_c119.o compile_to_c120.o compile_to_c121.o compile_to_c122.o compile_to_c123.o compile_to_c124.o compile_to_c125.o compile_to_c126.o compile_to_c127.o compile_to_c128.o compile_to_c129.o compile_to_c130.o compile_to_c131.o compile_to_c132.o compile_to_c133.o compile_to_c134.o compile_to_c135.o -x none
 strip a.out